﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.SqlClient;
using System.Configuration;
using System.Data;

namespace DataAccess
{
    public class InvoiceAccess
    {
        public Invoice[] GetData()
        {
            List<Invoice> result = new List<Invoice>();
            using (SqlConnection conn = new SqlConnection(ConfigurationManager.ConnectionStrings["ChinookConnectionString"].ConnectionString))
            {
                conn.Open();
                using (SqlCommand cmd = new SqlCommand("Select * from Invoice", conn))
                {
                    using (SqlDataReader reader = cmd.ExecuteReader())
                    {
                        while (reader.Read())
                        {
                            result.Add(new Invoice()
                            {
                                InvoiceId = (int)reader["InvoiceId"],
                                CustomerId = (int)reader["CustomerId"],
                                InvoiceDate = (DateTime)reader["InvoiceDate"],
                                BillingAddress = (string)reader["BillingAddress"],
                                BillingCity = (string)reader["BillingCity"],
                                BillingState = reader["BillingState"] == DBNull.Value ? "" : (string)reader["BillingState"],
                                BillingCountry = (string)reader["BillingCountry"],
                                BillingPostalCode = reader["BillingPostalCode"] == DBNull.Value ? "" : (string)reader["BillingPostalCode"],
                                Total = (decimal)reader["Total"]
                            });
                        }
                    }
                }
            }

            return result.ToArray();
        }

        public DataTable GetDataTable()
        {
            DataTable result = new DataTable();
            using (SqlConnection conn = new SqlConnection(ConfigurationManager.ConnectionStrings["ChinookConnectionString"].ConnectionString))
            {
                conn.Open();
                using (SqlCommand cmd = new SqlCommand("Select * from Invoice", conn))
                {
                    using (SqlDataReader reader = cmd.ExecuteReader())
                    {
                        result.Load(reader);
                    }
                }
            }

            return result;
        }

        public void UpdateData()
        {
            using (SqlConnection conn = new SqlConnection(ConfigurationManager.ConnectionStrings["ChinookConnectionString"].ConnectionString))
            {
                conn.Open();
                using (SqlCommand cmd = new SqlCommand("Update Invoice Set InvoiceDate = GetDate() Where InvoiceId=1", conn))
                {
                    cmd.ExecuteNonQuery();
                }
            }
        }
    }
}
